.product-columns {

  // Loop from 1-8 and apply a width to the product list. This will allow
  // the changing of the container class to affect how products are shown.
  // This allows us to toggle the grid view from 3/4 etc.
  &-1{
    li.product{
      width: 100%;
    }
  }

  @for $i from 2 through 8 {
    // Count for @span
    $count: 12 / $i;

    // itaratons for the grid
    &-#{$i}{

      // When we're on mobile devices, we only
      // need to check if there are more than two
      @include not-wider-than(tablet){
        li.product{
          @include span( 6, 12, 0.75rem );
          &:nth-of-type(even){
            margin-right: 0;
            clear: right;
          }
          &:nth-of-type(odd){
            clear: left;
          }
        }
      } // End of tablet

      // Inbetween tablets and laptops, we're
      // going to have just two products
      @include wider-than(tablet){
        @include not-wider-than(laptop){
          &.there-is-a-sidebar{
            li.product {
              @include span( 6, 12, 0.75rem );
              &:nth-of-type(even){
                margin-right: 0;
                clear: right;
              }
              &:nth-of-type(odd){
                clear: left;
              }
            }
          } // End of sidebar=yes
        }
      }

      // Tablet devices have 3 columns regardless
      // because we want to strip it down. Only
      // if there are 4 in the count though.
      @if $i >= 3 {
        @include wider-than(tablet){
          @include not-wider-than(desktop){

            &.there-is-no-sidebar{
              li.product {
                @include span( 4, 12, 0.8rem );
                &:nth-of-type(3n+3){
                  margin-right: 0;
                  clear: right;
                }
                &:nth-of-type(3n+4){
                  clear: left;
                }
              }
            } // End of sidebar=no

            // Sidebar makes everything upsetting
            &.there-is-a-sidebar{
              li.product {
                @include span( 6, 12, 0.75rem );
                &:nth-of-type(even){
                  margin-right: 0;
                  clear: right;
                }
                &:nth-of-type(odd){
                  clear: left;
                }
              }
            } // End of sidebar=yes
          }
        }
      } // End of $i>=3 loop


      // When on desktop devices, we're going
      // to go for the $count as it is. no changing.
      @include wider-than(desktop){
          li.product {
          @include span( $count, 12, 1rem );
          &:nth-of-type( #{$i}n+#{$i} ) {
            margin-right: 0;
          }
          &:nth-of-type( #{$i}n+#{$i+1} ) {
            clear: left;
          }
        }
      } // End of desktop

    }
  }
}
